import { ElementRef, OnInit, AfterContentInit, AfterViewInit, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
/**
 * LayoutLeftContainer
 */
export declare class LayoutLeftContainer implements OnInit, OnDestroy, AfterViewInit {
    layout: Layout;
    cdref: ChangeDetectorRef;
    width: string;
    header: string;
    icon: string;
    headerEle: ElementRef;
    bodyEle: ElementRef;
    bodyHeight: string;
    constructor(layout: Layout, cdref: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
/**
 * LayoutCenterContainer
 */
export declare class LayoutCenterContainer implements OnInit, AfterViewInit, OnDestroy {
    layout: Layout;
    domhandler: DomHandler;
    cdref: ChangeDetectorRef;
    width: string;
    header: string;
    icon: string;
    headerEle: ElementRef;
    bodyEle: ElementRef;
    style: any;
    left: string;
    bodyHeight: string;
    timer: any;
    absoluteWidth: boolean;
    constructor(layout: Layout, domhandler: DomHandler, cdref: ChangeDetectorRef);
    onResize(event: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    setWidth(): void;
    setResizeWidth(): void;
}
/**
 * LayoutRightContainer
 */
export declare class LayoutRightContainer implements OnInit, AfterViewInit, OnDestroy {
    layout: Layout;
    domhandler: DomHandler;
    cdref: ChangeDetectorRef;
    width: string;
    header: string;
    icon: string;
    headerEle: ElementRef;
    bodyEle: ElementRef;
    style: any;
    left: string;
    bodyHeight: string;
    constructor(layout: Layout, domhandler: DomHandler, cdref: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
/**
 * Layout
 */
export declare class Layout implements OnInit, AfterViewInit, AfterContentInit, OnDestroy {
    domhandler: DomHandler;
    el: ElementRef;
    cdref: ChangeDetectorRef;
    height: string;
    width: string;
    widthDiff: string;
    heightDiff: string;
    border: boolean;
    splitter: boolean;
    LayoutLeftContainer: any;
    LayoutCenterContainer: any;
    LayoutRightContainer: any;
    splitterSize: number;
    containerHeight: string;
    containerWidth: string;
    absoluteWidth: boolean;
    onResize(event: any): void;
    constructor(domhandler: DomHandler, el: ElementRef, cdref: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    setContainerHeight(): string;
    setContainerWidth(): string;
    setResizeContainerWidth(): string;
    setLayoutHeight(): string;
}
export declare class LayoutModule {
}
