"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var domhandler_1 = require("../dom/domhandler");
/**
 * LayoutLeftContainer
 */
var LayoutLeftContainer = (function () {
    function LayoutLeftContainer(layout, cdref) {
        this.layout = layout;
        this.cdref = cdref;
        this.width = '100';
    }
    LayoutLeftContainer.prototype.ngOnInit = function () {
    };
    LayoutLeftContainer.prototype.ngAfterViewInit = function () {
        var headerH = this.headerEle ? this.headerEle.nativeElement.offsetHeight : 0;
        this.bodyHeight = (parseInt(this.layout.containerHeight) - headerH) + 'px';
        this.cdref.detectChanges();
    };
    LayoutLeftContainer.prototype.ngOnDestroy = function () {
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LayoutLeftContainer.prototype, "width", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LayoutLeftContainer.prototype, "header", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LayoutLeftContainer.prototype, "icon", void 0);
    __decorate([
        core_1.ViewChild('headerEle'),
        __metadata("design:type", core_1.ElementRef)
    ], LayoutLeftContainer.prototype, "headerEle", void 0);
    __decorate([
        core_1.ViewChild('bodyEle'),
        __metadata("design:type", core_1.ElementRef)
    ], LayoutLeftContainer.prototype, "bodyEle", void 0);
    LayoutLeftContainer = __decorate([
        core_1.Component({
            selector: 'p-layout-left',
            template: "\n        <div class=\"ui-layout-left\" [style.width.px]=\"width\" [class.blui-hidden]=\"width=='0'\">\n            <div #headerEle *ngIf=\"header\" class=\"ui-layout-header\">\n                <i *ngIf=\"icon\" [ngClass]=\"icon\"></i>\n                {{header}}\n            </div>\n            <div #bodyEle class=\"ui-layout-body\" [style.height]=\"bodyHeight\">\n                <ng-content></ng-content>\n            </div>\n        </div>\n    ",
            providers: [domhandler_1.DomHandler]
        }),
        __param(0, core_1.Host()), __param(0, core_1.Inject(core_1.forwardRef(function () { return Layout; }))),
        __metadata("design:paramtypes", [Layout,
            core_1.ChangeDetectorRef])
    ], LayoutLeftContainer);
    return LayoutLeftContainer;
}());
exports.LayoutLeftContainer = LayoutLeftContainer;
/**
 * LayoutCenterContainer
 */
var LayoutCenterContainer = (function () {
    function LayoutCenterContainer(layout, domhandler, cdref) {
        this.layout = layout;
        this.domhandler = domhandler;
        this.cdref = cdref;
        // console.log(this)
    }
    LayoutCenterContainer.prototype.onResize = function (event) {
        if (this.absoluteWidth) {
            return;
        }
        clearTimeout(this.timer);
        this.timer = setTimeout(this.setResizeWidth(), 500);
    };
    LayoutCenterContainer.prototype.ngOnInit = function () {
        (this.width || this.layout.width) ? this.absoluteWidth = true : this.absoluteWidth = false;
        this.setWidth();
    };
    LayoutCenterContainer.prototype.ngAfterViewInit = function () {
        if (this.layout.LayoutLeftContainer && this.layout.LayoutRightContainer) {
            var w = parseInt(this.style.width, 10) - parseInt(this.layout.LayoutRightContainer.width, 10) - (this.layout.splitterSize);
            this.style.width = w + 'px';
        }
        var headerH = this.headerEle ? this.headerEle.nativeElement.offsetHeight : 0;
        this.bodyHeight = (parseInt(this.layout.containerHeight, 10) - headerH) + 'px';
        this.cdref.detectChanges();
    };
    LayoutCenterContainer.prototype.ngOnDestroy = function () {
    };
    LayoutCenterContainer.prototype.setWidth = function () {
        if (this.layout.LayoutLeftContainer) {
            var positionLeft = parseInt(this.layout.LayoutLeftContainer.width, 10);
            var splitterSize = 0;
            if (this.layout.splitter) {
                splitterSize = this.layout.splitterSize;
            }
            ;
            this.left = positionLeft + splitterSize + 'px';
            if (!this.width) {
                this.width = (parseInt(this.layout.containerWidth, 10) - positionLeft - splitterSize) + 'px';
            }
            else {
                this.width = null;
            }
            this.style = {
                left: this.left,
                width: this.width
            };
        }
    };
    LayoutCenterContainer.prototype.setResizeWidth = function () {
        if (this.layout.LayoutLeftContainer) {
            if (this.layout.LayoutRightContainer) {
                var w = parseInt(this.layout.containerWidth, 10)
                    - parseInt(this.layout.LayoutLeftContainer.width, 10)
                    - parseInt(this.layout.LayoutRightContainer.width, 10)
                    - (this.layout.splitterSize * 2);
                this.width = w + 'px';
            }
            else {
                this.width = (parseInt(this.layout.containerWidth, 10) - parseInt(this.left, 10)) + 'px';
            }
        }
        this.style = {
            left: this.left,
            width: this.width
        };
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LayoutCenterContainer.prototype, "width", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LayoutCenterContainer.prototype, "header", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LayoutCenterContainer.prototype, "icon", void 0);
    __decorate([
        core_1.ViewChild('headerEle'),
        __metadata("design:type", core_1.ElementRef)
    ], LayoutCenterContainer.prototype, "headerEle", void 0);
    __decorate([
        core_1.ViewChild('bodyEle'),
        __metadata("design:type", core_1.ElementRef)
    ], LayoutCenterContainer.prototype, "bodyEle", void 0);
    __decorate([
        core_1.HostListener('window:resize', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], LayoutCenterContainer.prototype, "onResize", null);
    LayoutCenterContainer = __decorate([
        core_1.Component({
            selector: 'p-layout-center',
            template: "\n        <div [ngStyle]=\"style\" class=\"ui-layout-center\">\n            <div #headerEle *ngIf=\"header\" class=\"ui-layout-header\">\n                <i *ngIf=\"icon\" [ngClass]=\"icon\"></i>\n                {{header}}\n            </div>\n            <div #bodyEle class=\"ui-layout-body\" [style.height]=\"bodyHeight\">\n                <ng-content></ng-content>\n            </div>\n        </div>\n    ",
            providers: [domhandler_1.DomHandler]
        }),
        __param(0, core_1.Host()), __param(0, core_1.Inject(core_1.forwardRef(function () { return Layout; }))),
        __metadata("design:paramtypes", [Layout,
            domhandler_1.DomHandler,
            core_1.ChangeDetectorRef])
    ], LayoutCenterContainer);
    return LayoutCenterContainer;
}());
exports.LayoutCenterContainer = LayoutCenterContainer;
/**
 * LayoutRightContainer
 */
var LayoutRightContainer = (function () {
    function LayoutRightContainer(layout, domhandler, cdref) {
        this.layout = layout;
        this.domhandler = domhandler;
        this.cdref = cdref;
        this.width = '100';
        // console.log(this)
    }
    LayoutRightContainer.prototype.ngOnInit = function () {
        if (this.layout.LayoutLeftContainer) {
            /*let positionLeft = parseInt(this.layout.LayoutLeftContainer.width);
            let positionCenter = parseInt(this.layout.LayoutCenterContainer.width);
            let splitterSize = 0;
            if(this.layout.splitter) splitterSize = this.layout.splitterSize;
            
            this.left = positionLeft + positionCenter + splitterSize*2 + 'px';*/
            this.style = {
                right: 0,
                width: parseInt(this.width) + 'px'
            };
        }
    };
    LayoutRightContainer.prototype.ngAfterViewInit = function () {
        var headerH = this.headerEle ? this.headerEle.nativeElement.offsetHeight : 0;
        this.bodyHeight = (parseInt(this.layout.containerHeight) - headerH) + 'px';
        this.cdref.detectChanges();
    };
    LayoutRightContainer.prototype.ngOnDestroy = function () {
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LayoutRightContainer.prototype, "width", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LayoutRightContainer.prototype, "header", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LayoutRightContainer.prototype, "icon", void 0);
    __decorate([
        core_1.ViewChild('headerEle'),
        __metadata("design:type", core_1.ElementRef)
    ], LayoutRightContainer.prototype, "headerEle", void 0);
    __decorate([
        core_1.ViewChild('bodyEle'),
        __metadata("design:type", core_1.ElementRef)
    ], LayoutRightContainer.prototype, "bodyEle", void 0);
    LayoutRightContainer = __decorate([
        core_1.Component({
            selector: 'p-layout-right',
            template: "\n        <div [ngStyle]=\"style\" class=\"ui-layout-right\" [class.blui-hidden]=\"width=='0'\">\n            <div #headerEle *ngIf=\"header\" class=\"ui-layout-header\">\n                <i *ngIf=\"icon\" [ngClass]=\"icon\"></i>\n                {{header}}\n            </div>\n            <div #bodyEle class=\"ui-layout-body\" [style.height]=\"bodyHeight\">\n                <ng-content></ng-content>\n            </div>\n        </div>\n    ",
            providers: [domhandler_1.DomHandler]
        }),
        __param(0, core_1.Host()), __param(0, core_1.Inject(core_1.forwardRef(function () { return Layout; }))),
        __metadata("design:paramtypes", [Layout,
            domhandler_1.DomHandler,
            core_1.ChangeDetectorRef])
    ], LayoutRightContainer);
    return LayoutRightContainer;
}());
exports.LayoutRightContainer = LayoutRightContainer;
/**
 * Layout
 */
var Layout = (function () {
    function Layout(domhandler, el, cdref) {
        this.domhandler = domhandler;
        this.el = el;
        this.cdref = cdref;
        this.splitterSize = 5;
        this.containerHeight = '200px';
        this.containerWidth = 'atuo';
    }
    Layout.prototype.onResize = function (event) {
        if (this.absoluteWidth) {
            return;
        }
        this.containerHeight = this.setContainerHeight();
        this.containerWidth = this.setResizeContainerWidth();
    };
    Layout.prototype.ngOnInit = function () {
        this.width ? this.absoluteWidth = true : this.absoluteWidth = false;
        this.containerHeight = this.setContainerHeight();
        this.containerWidth = this.setContainerWidth();
        /* if(!this.width){
            this.width = this.el.nativeElement.children[0].offsetWidth + 'px';
        } */
    };
    Layout.prototype.ngAfterContentInit = function () {
    };
    Layout.prototype.ngAfterViewInit = function () {
    };
    Layout.prototype.ngOnDestroy = function () {
    };
    Layout.prototype.setContainerHeight = function () {
        if (this.height) {
            if (this.height.indexOf('%') === -1) {
                this.height = parseInt(this.height, 10) + 'px';
            }
            return this.height;
        }
        else {
            return this.setLayoutHeight();
        }
    };
    Layout.prototype.setContainerWidth = function () {
        var widthDiff = this.widthDiff ? parseInt(this.widthDiff, 10) : 0;
        var containerWidth;
        if (this.width) {
            if (this.width.indexOf('%') === -1) {
                containerWidth = parseInt(this.width, 10) + widthDiff + 'px';
            }
            return containerWidth;
        }
        else {
            return this.el.nativeElement.children[0].offsetWidth + widthDiff + 'px';
        }
    };
    Layout.prototype.setResizeContainerWidth = function () {
        var w = this.domhandler.getWidth(this.el.nativeElement.parentNode);
        return w + 'px';
    };
    Layout.prototype.setLayoutHeight = function () {
        var parentHeight = this.domhandler.getHeight(this.el.nativeElement.parentNode);
        var children = this.el.nativeElement.parentNode.children;
        var resHeight = 0;
        if (children.length > 1) {
            for (var index = 0; index < children.length; index++) {
                if (children[index].nodeName !== 'P-LAYOUT') {
                    resHeight += this.domhandler.getOuterHeight(children[index], true);
                }
            }
        }
        if (parentHeight > 200) {
            return (parentHeight - resHeight) + 'px';
        }
        else {
            console.warn('P-LAYOUT: 父元素高度少于200，调整最低高度为：200px');
            return '200px';
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], Layout.prototype, "height", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], Layout.prototype, "width", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], Layout.prototype, "widthDiff", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], Layout.prototype, "heightDiff", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], Layout.prototype, "border", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], Layout.prototype, "splitter", void 0);
    __decorate([
        core_1.ContentChild(LayoutLeftContainer),
        __metadata("design:type", Object)
    ], Layout.prototype, "LayoutLeftContainer", void 0);
    __decorate([
        core_1.ContentChild(LayoutCenterContainer),
        __metadata("design:type", Object)
    ], Layout.prototype, "LayoutCenterContainer", void 0);
    __decorate([
        core_1.ContentChild(LayoutRightContainer),
        __metadata("design:type", Object)
    ], Layout.prototype, "LayoutRightContainer", void 0);
    __decorate([
        core_1.HostListener('window:resize', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], Layout.prototype, "onResize", null);
    Layout = __decorate([
        core_1.Component({
            selector: 'p-layout',
            template: "\n        <div class=\"ui-layout\" [ngClass]=\"{'ui-layout-border': border}\" [style.height]=\"containerHeight\" [style.width]=\"containerWidth\">\n            <ng-content select=\"p-layout-left\"></ng-content>\n            <ng-content select=\"p-layout-center\"></ng-content>\n            <ng-content select=\"p-layout-right\"></ng-content>\n        </div>\n    ",
            providers: [domhandler_1.DomHandler]
        }),
        __metadata("design:paramtypes", [domhandler_1.DomHandler, core_1.ElementRef, core_1.ChangeDetectorRef])
    ], Layout);
    return Layout;
}());
exports.Layout = Layout;
var LayoutModule = (function () {
    function LayoutModule() {
    }
    LayoutModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule],
            exports: [Layout, LayoutLeftContainer, LayoutCenterContainer, LayoutRightContainer],
            declarations: [Layout, LayoutLeftContainer, LayoutCenterContainer, LayoutRightContainer]
        })
    ], LayoutModule);
    return LayoutModule;
}());
exports.LayoutModule = LayoutModule;
//# sourceMappingURL=layout.js.map