import { EventEmitter, OnInit, ElementRef, OnChanges, SimpleChanges } from '@angular/core';
import { TreeNode } from '../common/api';
export declare const SELECTSTATION_VALUE_ACCESSOR: any;
export declare class SelectStation implements OnInit, OnChanges {
    modal: boolean;
    visible: boolean;
    visibleChange: EventEmitter<boolean>;
    dataTree: any[];
    dataGrid: any[];
    dataGridPaginator: string;
    dataGridColumn: any[];
    dataGridSelectedKey: string;
    dataGridSelection: any[];
    dataGridSelectionChange: EventEmitter<any>;
    onNodeSelect: EventEmitter<any>;
    onSureBtnClick: EventEmitter<any>;
    onSearchBtnClick: EventEmitter<any>;
    onTreeSearchBtnClick: EventEmitter<any>;
    selectionMode: string;
    styleClass: string;
    private _extOptions;
    extOptions: SelectStationExtOptions;
    treeStyle: any;
    dataGridScrollHeight: string;
    dataTreeSelection: TreeNode;
    treeExpandStatus: boolean;
    showTreeSeach: boolean;
    treeInputSearch: ElementRef;
    inputSearch: ElementRef;
    ngOnChanges(changes: SimpleChanges): void;
    constructor();
    ngOnInit(): void;
    /**
     * tree
     */
    nodeSelect(event: any): void;
    nodeUnselect(event: any): void;
    toggleExpandAll(): void;
    expandAll(): void;
    collapseAll(): void;
    private expandRecursive(node, isExpand);
    onHide(): void;
    getDataGridSelection(): void;
    removeItem(index: any, item: any): void;
    treeSearchBtnClick(event: any): void;
    searchBtnClick(event: any): void;
    helperRender(): void;
}
export declare class SelectStationModule {
}
/**
 * dialogTitle 弹窗标题
 * dialogWidth 弹窗宽度
 * dialogHeight 弹窗高度
 * leftHeaderTitle 左侧panel标题
 * leftWidth 左侧panel宽度,为0时，不展现左侧区
 * centerHeaderTitle 中间panel标题
 * rightHeaderTitle 右侧panel标题
 * rightWidth 右侧panel宽度,为0时，不展现右侧区
 * expandAllLabel 展开按钮文本描述
 * collapseAllLabel 收起按钮文本描述
 * expandAllIcon 展开按钮图标 font-awesome图标
 * collapseAllIcon 收起按钮图标 font-awesome图标
 * @export
 * @interface SelectStationExtOptions
 */
export interface SelectStationExtOptions {
    dialogTitle?: string;
    dialogWidth?: string;
    dialogHeight?: string;
    leftHeaderTitle?: string;
    leftWidth?: string;
    centerHeaderTitle?: string;
    rightHeaderTitle?: string;
    rightWidth?: string;
    expandAllLabel?: string;
    collapseAllLabel?: string;
    expandAllIcon?: string;
    collapseAllIcon?: string;
}
