"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var paginator_1 = require("./../paginator/paginator");
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var dialog_1 = require("../dialog/dialog");
var button_1 = require("../button/button");
var layout_1 = require("../layout/layout");
var tree_1 = require("../tree/tree");
var datatable_1 = require("../datatable/datatable");
var forms_1 = require("@angular/forms");
exports.SELECTSTATION_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return SelectStation; }),
    multi: true
};
var SelectStation = (function () {
    function SelectStation() {
        // 是否显示遮罩
        this.modal = true;
        this.visibleChange = new core_1.EventEmitter();
        // 分页模式 默认sync。 sync/async
        this.dataGridPaginator = 'sync';
        this.dataGridSelectionChange = new core_1.EventEmitter();
        // 树选择事件
        this.onNodeSelect = new core_1.EventEmitter();
        // 确定事件
        this.onSureBtnClick = new core_1.EventEmitter();
        // 搜索事件
        this.onSearchBtnClick = new core_1.EventEmitter();
        // 搜索事件
        this.onTreeSearchBtnClick = new core_1.EventEmitter();
        // 扩展配置
        this._extOptions = {
            dialogTitle: '窗口',
            dialogWidth: '950',
            dialogHeight: '420',
            leftHeaderTitle: '信息树',
            leftWidth: '280',
            centerHeaderTitle: '列表',
            rightHeaderTitle: '已选中列表',
            rightWidth: '160',
            expandAllLabel: '展开',
            collapseAllLabel: '收起',
            expandAllIcon: 'fa-expand',
            collapseAllIcon: 'fa-compress'
        };
    }
    Object.defineProperty(SelectStation.prototype, "extOptions", {
        get: function () { return this._extOptions; },
        set: function (extOptions) {
            this._extOptions = Object.assign(this._extOptions, extOptions);
        },
        enumerable: true,
        configurable: true
    });
    SelectStation.prototype.ngOnChanges = function (changes) {
        if (changes.dataTree && changes.dataTree.currentValue && !changes.dataTree.previousValue) {
            // 初始化时展开树节点
            this.expandAll();
        }
    };
    SelectStation.prototype.ngOnInit = function () {
        this.helperRender();
    };
    /**
     * tree
     */
    SelectStation.prototype.nodeSelect = function (event) {
        // console.log('发出')
        this.onNodeSelect.emit(event);
    };
    SelectStation.prototype.nodeUnselect = function (event) {
        // console.log(event)
    };
    SelectStation.prototype.toggleExpandAll = function () {
        this.treeExpandStatus ? this.collapseAll() : this.expandAll();
    };
    SelectStation.prototype.expandAll = function () {
        var _this = this;
        this.treeExpandStatus = true;
        this.dataTree.forEach(function (node) {
            _this.expandRecursive(node, true);
        });
    };
    SelectStation.prototype.collapseAll = function () {
        var _this = this;
        this.treeExpandStatus = false;
        this.dataTree.forEach(function (node) {
            _this.expandRecursive(node, false);
        });
    };
    SelectStation.prototype.expandRecursive = function (node, isExpand) {
        var _this = this;
        node.expanded = isExpand;
        if (node.children) {
            node.children.forEach(function (childNode) {
                _this.expandRecursive(childNode, isExpand);
            });
        }
    };
    SelectStation.prototype.onHide = function () {
        this.visible = false;
        this.visibleChange.emit(this.visible);
    };
    // 确定事件
    SelectStation.prototype.getDataGridSelection = function () {
        this.visible = false;
        this.visibleChange.emit(this.visible);
        this.onSureBtnClick.emit(this.dataGridSelection);
    };
    // 删除事件
    SelectStation.prototype.removeItem = function (index, item) {
        this.dataGridSelection = this.dataGridSelection.filter(function (val, i) {
            return i !== index;
        });
        this.dataGridSelectionChange.emit(this.dataGridSelection);
    };
    SelectStation.prototype.treeSearchBtnClick = function (event) {
        var v = this.treeInputSearch.nativeElement.value.trim();
        this.onTreeSearchBtnClick.emit({ value: v });
    };
    // 本地过滤 未使用
    /* filterTreeData(keyword: string) {
        this.dataTree.filter(
            (value) => {
                return value.label.indexOf(keyword) !== -1;
            }
        );
    } */
    // 搜索事件 (async模式)
    SelectStation.prototype.searchBtnClick = function (event) {
        var v = this.inputSearch.nativeElement.value.trim();
        this.onSearchBtnClick.emit({ value: v });
    };
    // 辅助渲染
    SelectStation.prototype.helperRender = function () {
        var treeToolbarHeight = 0;
        if (this.onTreeSearchBtnClick.observers.length > 0) {
            this.showTreeSeach = true;
            treeToolbarHeight = 45;
        }
        var h1 = this.dataGridPaginator === 'async' ? 114 : 110;
        this.dataGridScrollHeight = parseInt(this.extOptions.dialogHeight, 10) - h1 + 'px';
        this.treeStyle = {
            height: parseInt(this.extOptions.dialogHeight, 10) - 50 - treeToolbarHeight + 'px',
            overflow: 'auto'
        };
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], SelectStation.prototype, "modal", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], SelectStation.prototype, "visible", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], SelectStation.prototype, "visibleChange", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], SelectStation.prototype, "dataTree", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], SelectStation.prototype, "dataGrid", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SelectStation.prototype, "dataGridPaginator", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], SelectStation.prototype, "dataGridColumn", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SelectStation.prototype, "dataGridSelectedKey", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], SelectStation.prototype, "dataGridSelection", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], SelectStation.prototype, "dataGridSelectionChange", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], SelectStation.prototype, "onNodeSelect", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], SelectStation.prototype, "onSureBtnClick", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], SelectStation.prototype, "onSearchBtnClick", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], SelectStation.prototype, "onTreeSearchBtnClick", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SelectStation.prototype, "selectionMode", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SelectStation.prototype, "styleClass", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], SelectStation.prototype, "extOptions", null);
    __decorate([
        core_1.ViewChild('treeInput'),
        __metadata("design:type", core_1.ElementRef)
    ], SelectStation.prototype, "treeInputSearch", void 0);
    __decorate([
        core_1.ViewChild('gb'),
        __metadata("design:type", core_1.ElementRef)
    ], SelectStation.prototype, "inputSearch", void 0);
    SelectStation = __decorate([
        core_1.Component({
            selector: 'p-selectstation',
            template: "\n    <p-dialog [(visible)]=\"visible\" [modal]=\"modal\" [responsive]=\"false\" [styleClass]=\"styleClass\" (onHide)=\"onHide($event)\">\n        <p-header>\n            {{extOptions.dialogTitle}}\n        </p-header>\n        <div class=\"blui-selectstation\">\n            <p-layout [height]=\"extOptions.dialogHeight\" [width]=\"extOptions.dialogWidth\" [border]=\"true\" [splitter]=\"true\">\n                <p-layout-left [width]=\"extOptions.leftWidth\">\n                    <p-header>\n                        <div class=\"ui-helper-clearfix blui-toolbar\">\n                            <span>{{extOptions.leftHeaderTitle}}</span>\n                            <button class=\"ui-button-secondary pull-right\" type=\"button\" pButton\n                                icon=\"{{treeExpandStatus ? extOptions.collapseAllIcon : extOptions.expandAllIcon}}\" (click)=\"toggleExpandAll()\"\n                                label=\"{{treeExpandStatus ? extOptions.collapseAllLabel : extOptions.expandAllLabel}}\"></button>\n                            <!--\n                            <button class=\"ui-button-secondary\" type=\"button\" pButton icon=\"fa-expand\" (click)=\"expandAll()\" label=\"\u5C55\u5F00\"></button>\n                            <button class=\"ui-button-secondary\" type=\"button\" pButton icon=\"fa-compress\" (click)=\"collapseAll()\" label=\"\u6536\u8D77\"></button>\n                            -->\n                        </div>\n                        <div *ngIf=\"showTreeSeach\" class=\"ui-inputgroup blui-toolbar treesearch-toolbar\">\n                            <input #treeInput class=\"ui-input-treesearch\" type=\"text\" pInputText placeholder=\"\u8BF7\u8F93\u5165\u641C\u7D22\u5185\u5BB9\">\n                            <button pButton type=\"button\" icon=\"fa-search\" class=\"ui-button-secondary\" (click)=\"treeSearchBtnClick($event)\"></button>\n                        </div>\n                    </p-header>\n                    <div [ngStyle]=\"treeStyle\">\n                        <p-tree styleClass=\"blui-tree\" [value]=\"dataTree\" selectionMode=\"single\" [(selection)]=\"dataTreeSelection\" \n                            (onNodeSelect)=\"nodeSelect($event)\" (onNodeUnselect)=\"nodeUnselect($event)\">\n                        </p-tree>\n                    </div>\n                </p-layout-left>\n                <p-layout-center>\n                    <p-dataTable *ngIf=\"dataGridPaginator=='sync'\" [value]=\"dataGrid\" selectionMode=\"multiple\" [(selection)]=\"dataGridSelection\" scrollable=\"true\" [scrollHeight]=\"dataGridScrollHeight\" [rows]=\"20\" [paginator]=\"true\" [globalFilter]=\"gb\">\n                        <p-header>\n                            <div class=\"ui-helper-clearfix blui-grid-toolbar\">\n                                <div class=\"ui-inputgroup pull-right\">\n                                    <input #gb type=\"text\" pInputText placeholder=\"\u8BF7\u8F93\u5165\u641C\u7D22\u5185\u5BB9\">\n                                    <button pButton type=\"button\" icon=\"fa-search\" class=\"ui-button-secondary\"></button>\n                                </div>\n                            </div>\n                        </p-header>\n                        <p-column *ngIf=\"selectionMode==='multiple'\" [style]=\"{'width':'38px'}\" selectionMode=\"multiple\"></p-column>\n                        <p-column *ngFor=\"let item of dataGridColumn\" field=\"{{item.field}}\" header=\"{{item.header}}\"></p-column>\n                    </p-dataTable>\n\n                    <div *ngIf=\"dataGridPaginator=='async'\">\n                        <p-dataTable [value]=\"dataGrid\" selectionMode=\"multiple\" [(selection)]=\"dataGridSelection\" scrollable=\"true\" [scrollHeight]=\"dataGridScrollHeight\">\n                            <p-header>\n                                <div class=\"ui-helper-clearfix blui-grid-toolbar\">\n                                    <div class=\"ui-inputgroup pull-right\">\n                                        <input #gb type=\"text\" pInputText placeholder=\"\u8BF7\u8F93\u5165\u641C\u7D22\u5185\u5BB9\">\n                                        <button pButton type=\"button\" icon=\"fa-search\" class=\"ui-button-secondary\" (click)=\"searchBtnClick($event)\"></button>\n                                    </div>\n                                </div>\n                            </p-header>\n                            <p-column *ngIf=\"selectionMode==='multiple'\" [style]=\"{'width':'38px'}\" selectionMode=\"multiple\"></p-column>\n                            <p-column *ngFor=\"let item of dataGridColumn\" field=\"{{item.field}}\" header=\"{{item.header}}\"></p-column>\n                        </p-dataTable>\n                        <ng-content select=\"p-paginator\"></ng-content>\n                    </div>\n                    \n                </p-layout-center>\n                <p-layout-right [width]=\"extOptions.rightWidth\" header=\"{{extOptions.rightHeaderTitle}}\">\n                    <ul class=\"ui-selectstation-selectedlist\">\n                        <li *ngFor=\"let item of dataGridSelection; let i=index;\" class=\"item\">\n                            {{item[dataGridSelectedKey]}} <i class=\"fa fa-times-circle close\" (click)=\"removeItem(i, item)\"></i>\n                        </li>\n                    </ul>\n                </p-layout-right>\n            </p-layout>\n        </div>\n        <p-footer>\n            <button type=\"button\" pButton icon=\"fa-close\" (click)=\"onHide()\" label=\"\u53D6\u6D88\"></button>\n            <button type=\"button\" pButton icon=\"fa-check\" (click)=\"getDataGridSelection()\" label=\"\u786E\u5B9A\"></button>\n        </p-footer>\n    </p-dialog>\n    ",
            providers: [exports.SELECTSTATION_VALUE_ACCESSOR]
        }),
        __metadata("design:paramtypes", [])
    ], SelectStation);
    return SelectStation;
}());
exports.SelectStation = SelectStation;
var SelectStationModule = (function () {
    function SelectStationModule() {
    }
    SelectStationModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, dialog_1.DialogModule, button_1.ButtonModule, layout_1.LayoutModule, tree_1.TreeModule, datatable_1.DataTableModule, paginator_1.PaginatorModule],
            exports: [SelectStation],
            declarations: [SelectStation]
        })
    ], SelectStationModule);
    return SelectStationModule;
}());
exports.SelectStationModule = SelectStationModule;
//# sourceMappingURL=selectstation.js.map